/* utils.c generated by valac 0.40.11, the Vala compiler
 * generated from utils.vala, do not modify */

/*
 * Copyright (c) 2013 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	POMODORO_DATE_TIME_ERROR_PARSE
} PomodoroDateTimeError;
#define POMODORO_DATE_TIME_ERROR pomodoro_date_time_error_quark ()


GQuark pomodoro_date_time_error_quark (void);
GDateTime* pomodoro_datetime_from_string (const gchar* date_string,
                                          GError** error);
gchar* pomodoro_datetime_to_string (GDateTime* datetime);
gchar* pomodoro_format_time (gint seconds);
gdouble pomodoro_get_current_time (void);


GQuark
pomodoro_date_time_error_quark (void)
{
	return g_quark_from_static_string ("pomodoro_date_time_error-quark");
}


GDateTime*
pomodoro_datetime_from_string (const gchar* date_string,
                               GError** error)
{
	GDateTime* result = NULL;
	GTimeVal timeval = {0};
	GTimeVal _tmp1_;
	GDateTime* _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (date_string != NULL, NULL);
	g_get_current_time (&timeval);
	if (!g_time_val_from_iso8601 (date_string, &timeval)) {
		GError* _tmp0_;
		_tmp0_ = g_error_new (POMODORO_DATE_TIME_ERROR, POMODORO_DATE_TIME_ERROR_PARSE, "Could not parse string '%s'", date_string);
		_inner_error_ = _tmp0_;
		if (_inner_error_->domain == POMODORO_DATE_TIME_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp1_ = timeval;
	_tmp2_ = g_date_time_new_from_timeval_local (&_tmp1_);
	result = _tmp2_;
	return result;
}


gchar*
pomodoro_datetime_to_string (GDateTime* datetime)
{
	gchar* result = NULL;
	GTimeVal timeval = {0};
	gchar* date_string = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GTimeVal _tmp2_ = {0};
	gboolean _tmp3_;
	gboolean _tmp4_;
	g_return_val_if_fail (datetime != NULL, NULL);
	g_get_current_time (&timeval);
	_tmp0_ = g_date_time_to_utc (datetime);
	_tmp1_ = _tmp0_;
	_tmp3_ = g_date_time_to_timeval (_tmp1_, &_tmp2_);
	timeval = _tmp2_;
	_tmp4_ = _tmp3_;
	_g_date_time_unref0 (_tmp1_);
	if (_tmp4_) {
		gchar* _tmp5_;
		_tmp5_ = g_time_val_to_iso8601 (&timeval);
		_g_free0 (date_string);
		date_string = _tmp5_;
	} else {
		_g_free0 (date_string);
		date_string = NULL;
	}
	result = date_string;
	return result;
}


gchar*
pomodoro_format_time (gint seconds)
{
	gchar* result = NULL;
	gint minutes = 0;
	gint hours = 0;
	gchar* str = NULL;
	gchar* _tmp0_;
	gint _tmp1_;
	gboolean _tmp5_ = FALSE;
	gint _tmp6_;
	gint _tmp10_;
	minutes = (seconds / 60) % 60;
	hours = seconds / 3600;
	_tmp0_ = g_strdup ("");
	str = _tmp0_;
	_tmp1_ = hours;
	if (_tmp1_ > 0) {
		gint _tmp2_;
		gint _tmp3_;
		gchar* _tmp4_;
		_tmp2_ = hours;
		_tmp3_ = hours;
		_tmp4_ = g_strdup_printf (ngettext ("%d hour", "%d hours", (gulong) _tmp2_), _tmp3_);
		_g_free0 (str);
		str = _tmp4_;
	}
	_tmp6_ = minutes;
	if (_tmp6_ > 0) {
		const gchar* _tmp7_;
		_tmp7_ = str;
		_tmp5_ = _tmp7_ != NULL;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		const gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp8_ = str;
		_tmp9_ = g_strconcat (_tmp8_, " ", NULL);
		_g_free0 (str);
		str = _tmp9_;
	}
	_tmp10_ = minutes;
	if (_tmp10_ > 0) {
		const gchar* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		_tmp11_ = str;
		_tmp12_ = minutes;
		_tmp13_ = minutes;
		_tmp14_ = g_strdup_printf (ngettext ("%d minute", "%d minutes", (gulong) _tmp12_), _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_strconcat (_tmp11_, _tmp15_, NULL);
		_g_free0 (str);
		str = _tmp16_;
		_g_free0 (_tmp15_);
	}
	result = str;
	return result;
}


/**
     * Returns the number of seconds since January 1, 1970 UTC.
     */
gdouble
pomodoro_get_current_time (void)
{
	gdouble result = 0.0;
	result = ((gdouble) g_get_real_time ()) / 1000000.0;
	return result;
}



